#include "../include/execute_cvs_cmd.h"

#include <string>
using namespace std;

char buf[1025];

int execute_cvs_cmd(char * const *cvs_cmd, std::string& result)
{
	int  master, slave;
	int  n, pid, retValue;
	std::string msg;
	int  len;

	retValue = open_pty_pair(&master, &slave);
	if(!retValue) {
		return retValue;
	}/* if(!retValue) */

	if (!fork()) {
		/*
		 * detach from orginal tty.
		 */
		ioctl(0, TIOCNOTTY,NULL);
        
		dup2(slave, 0);
		dup2(slave, 1);
		dup2(slave, 2);

		close(master);
		close(slave);
        
		execvp (cvs_cmd[0], cvs_cmd);
		perror("execvp");
		exit(1);
	}/* if (!fork()) */

	/*
	 * You must close slave in the master to get proper shutdown of the
	 * descriptor when the child dies.
	 */
	close(slave);
	memset(buf, 0, sizeof(buf));
	while ((n = read(master, buf, 1024)) > 0) {
		msg = msg + buf;
	}/* while ((n = read(master, buf, 1024)) > 0) */
    
	close(master);

	if(!msg.empty()) {
		result = msg;
	}/* if(!msg.empty()) */
    
	return 1;
}/* execute_cvs_cmd() */

int execute_cvs_cmd(char * const *cvs_cmd, std::string& result, std::string password)
{
	int  master, slave;
	int  n, pid, retValue;
	std::string msg;
	int  len;

	retValue = open_pty_pair(&master, &slave);
	if(!retValue) {
		return retValue;
	}/* if(!retValue) */

	if (!fork()) {
		/*
		 * detach from orginal tty.
		 */
		ioctl(0, TIOCNOTTY,NULL);
        
		dup2(slave, 0);
		dup2(slave, 1);
		dup2(slave, 2);

		close(master);
		close(slave);
        
		execvp (cvs_cmd[0], cvs_cmd);
		perror("execvp");
		exit(1);
	}/* if (!fork()) */

	/*
	 * You must close slave in the master to get proper shutdown of the
	 * descriptor when the child dies.
	 */
	close(slave);

	memset(buf, 0, sizeof(buf));
	while ((n = read(master, buf, 1024)) > 0) {
		if (n > 10 && !strncmp((buf + n - 10), "password: ", 10)) {
			write(master, password.c_str(), strlen(password.c_str()));
			write(master, "\n", 1);
			break;
		}/* if (n > 10 && !strncmp((buf + n - 10), "password: ", 10)) */
		memset(buf, 0, sizeof(buf));
	}/* while ((n = read(master, buf, 1024)) > 0) */

	memset(buf, 0, sizeof(buf));
	while ((n = read(master, buf, 1024)) > 0) {
		msg = msg + buf;
	}/* while ((n = read(master, buf, 1024)) > 0) */
    
	close(master);

	if(!msg.empty()) {
		result = msg;
	}/* if(!msg.empty()) */
    
	return 1;
}/* execute_cvs_cmd() */

